//
//  mdlWorkOrderAttachment.swift
//
//
//  Created by Michiel Carman on 2/16/24.
//


import Fluent
import Vapor
import Foundation
import FluentKit

final class mdlWorkOrderAttachment: Model, Content {
    static let schema = "workOrderAttachment"
    
    @ID(custom: "id", generatedBy: .database) var id: Int?
    
    @Parent(key: "workOrderId") var workorder: mdlWorkOrder
    @Parent(key: "equipmentId") var equipment: mdlEquipment
    
    @Timestamp(key: "createDate", on: .create) var createdate: Date?
    @Field(key: "createUserId") var createuserid: Int?
    @Timestamp(key: "updateDate", on: .update) var updatedate: Date?
    @Field(key: "updateUserId") var updateuserid: Int?
    
    init() { }
    
    init(id: Int? = nil,
         workorderid: Int,
         equipmentid: Int,
         createuserid: Int? = -1,
         updateuserid: Int? = -1
    ) {
        self.id = id
        self.$workorder.$id.value = workorderid
        self.$equipment.$id.value = equipmentid
        self.createuserid = createuserid
        self.updateuserid = updateuserid
    }
}
extension mdlWorkOrderAttachment{
    struct Create: AsyncMigration {
        func prepare(on database: Database) async throws {
            try await database.schema("workOrderAttachment")
                .field("id", .int, .identifier(auto: true))
                .field("workOrderId", .int, .references("workOrder", "id"))
                .field("equipmentId", .int, .references("equipment", "id"))
                .field("createDate", .datetime)
                .field("createUserId", .int)
                .field("updateDate", .datetime)
                .field("updateUserId", .int)
                .create()
        }
        
        func revert(on database: Database) async throws {
            try await database.schema("workOrderAttachment").delete()
        }
    }
    public static func ObjQuery(req: Request) async throws -> QueryBuilder<mdlWorkOrderAttachment>{
        
        let query = mdlWorkOrderAttachment.query(on: req.db)
            .with(\.$workorder)
            .with(\.$equipment)
        
        if let x = req.parameters.get("x"){
            let decryptedString = try CustomCrypto.DecryptString(input: x)
            let array =  decryptedString.components(separatedBy: ":")
            ///This call is the standard get by id call
            if (array.count == 1){
                let id = Int(array[0])!
                return query.filter(\.$id == id)
            }
            ///Optional else if if there are multiple parameters in the call
            ///You must include an else for each call that has parameters
            ///Need to check the endpoint to get the right filter statements
            ///else if(x.count == 2){
            ///    let username = x[0]
            ///    let password = x[1]
            ///    return query.filter(\.$username == username).filter(\.$password == password)
            ///}
            else{
                throw Abort(.badRequest)
            }
            
        }
        else{
            return query
        }
    }
}

